<template>

  <el-row class="container">
    <el-col :span="24" class="header">
      <el-col :span="12" class="logo" >
        {{sysName}}
      </el-col>

      <el-col :span="12" class="userinfo">

        <!---->
        <el-dropdown trigger="hover">
          <span class="el-dropdown-link userinfo-inner"><img :src="this.sysUserAvatar" /> {{user.email ? user.email : user.phone_number}}</span>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item @click.native="openDoc()">Dokumentasi</el-dropdown-item>
            <el-dropdown-item divided @click.native="logOut">Keluar</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
      </el-col>
    </el-col>
    <el-col :span="24" class="main">
      <section class="content-container">
        <el-row style="padding-bottom: 1em">
          <el-col :span="12" class="toolbar">
            <div style="display: inline-block">
              <el-input v-model="project_name" placeholder="Nama Project" type="text" @keyup.enter.native="createProject()"></el-input>
            </div>
            <div style="display: inline-block; margin: 0 10px;">
              <el-button type="primary" @click="createProject()">Buat Baru</el-button>
            </div>
          </el-col>
          <el-col :span="12" style="text-align: right;">
            <el-button type="primary" @click="openDoc()">Baca Dokumentasi</el-button>
          </el-col>
        </el-row>
        <el-table
          v-loading.body="loading"
          :data="projects">
          <el-table-column type="index" width="70"></el-table-column>

          <el-table-column prop="_project_name" label="Nama"></el-table-column>
          <el-table-column prop="_secret_key" label="Project URL" min-width="180">
            <template scope="scope">
              <el-popover trigger="hover" placement="bottom">
                <p>
                  Tekan untuk Menyalin
                </p>
                <div slot="reference" class="name-wrapper">
                  <el-tag type="success" v-clipboard="`http://${scope.row._secret_key}.lazyrest.arizalsaputro.me`"  @success="handleSuccess">{{`http://${scope.row._secret_key}.lazyrest.arizalsaputro.me`}} </el-tag>
                </div>
              </el-popover>
           </template>
          </el-table-column>
          <el-table-column prop="_access_token" label="Access Token" min-width="180">
            <template scope="scope">
              <el-popover trigger="hover" placement="bottom">
                <p>
                  Tekan untuk Menyalin
                </p>
                <div slot="reference" class="name-wrapper">
                  <el-tag type="danger" v-clipboard="scope.row._access_token" @success="handleSuccess">{{ scope.row._access_token }}</el-tag>
                </div>
              </el-popover>
            </template>
          </el-table-column>
          <el-table-column prop="_secure" label="Secure" width="100">
            <template scope="scope">
              <el-switch v-model="scope.row._secure" @change="updateData(scope.row)"></el-switch>
            </template>
          </el-table-column>
          <el-table-column fixed="right" label="Action" width="100">
            <template scope="scope">
              <el-button type="danger" size="small" @click="deleteData(scope.row)">Delete</el-button>
            </template>
          </el-table-column>
        </el-table>
        <el-col :span="24" class="toolbar" style="margin-top: 10px;">
          <el-pagination layout="total,prev, pager, next" @current-change="handleCurrentChange" :page-size="10" :total="total" style="float:right;">
          </el-pagination>
        </el-col>
      </section>
    </el-col>
  </el-row>

</template>

<script>
  import {mapState} from 'vuex'
  import axios from 'axios'
  import {BASE_URL} from './../store/config.env'
  import qs from 'qs'


  export default{
    middleware:'auth',
    data(){
      return {
        loading:false,
        sysName:'LazyRest',
        sysUserName:'Arizal',
        total:0,
        project_name:'',
        sysUserAvatar: 'https://i.pinimg.com/originals/3b/7d/6f/3b7d6f60e2d450b899c322266fc6edfd.png',
        projects:[],
        page: 1,
      }
    },
    computed: {
      ...mapState([
        'user'
      ])
    },
    methods:{
      handleSuccess(){
        this.$message({
          message: 'Berhasil Disalin',
          type: 'success'
        });
      },
      logOut(){
        this.$store.dispatch('logOut')
        window.location.reload()
      },
      openDoc(){
        let win = window.open("https://arizalsaputro.github.io/app-lazyrestapi-doc/", '_blank');
        win.focus();
      },
      handleCurrentChange(page){
          this.page = page;
        let options = qs.stringify({
          offset: (this.page-1)*10,
          limit:10
        });
        this.getData(options);
      },
      async createProject(){
        if(!this.project_name){
          return this.$message({
            message: "Masukan Nama Project",
            showClose: true,
            type: 'warning'
          });
        }
       // this.loading = true;
        await axios.post(`${BASE_URL}project`,{_project_name:this.project_name},{
          headers:{Authorization:'Bearer '+this.user.access_token}
        })
        this.project_name = '';
        this.getData();
      },
      async updateData(row){

          const {data} =await axios.put(`${BASE_URL}project/${row._id}`,{_secure:row._secure,},{
            headers:{Authorization:'Bearer '+this.user.access_token}
          })
          this.$message({
            message: "Berhasil di Perbarui",
            showClose: true,
            type: 'success'
          });
      },
      deleteData(row){
        this.$confirm('Apa anda yakin ingin menghapus project ini', 'Hapus Project', {
          confirmButtonText: 'Ya',
          cancelButtonText: 'Batal',
          type: 'warning'
        }).then(() => {
        //  this.loading = true;
          axios.delete(`${BASE_URL}project/${row._id}`,{
            headers:{Authorization:'Bearer '+this.user.access_token}
          }).then(res=>{
            this.loading =false;
            this.$notify({
              title: 'Success',
              message: 'Berhasil Menghapus Project',
              type: 'success'
            });
            this.getData();
          })
        }).catch(() => {

        });
      },
      getData(options='limit=10'){
        //this.loading = true;
        axios.get(`${BASE_URL}project?${options}`,{
          headers:{Authorization:'Bearer '+this.user.access_token}
        })
          .then( (response)=> {
            this.loading = false;
            if(response.data.data){
              this.total = response.data.meta.total_data;
              this.projects = response.data.data;
            }
          })
          .catch( (error)=> {
            this.loading = false;
            try{
              if(error.hasOwnProperty("response") && error.response.hasOwnProperty("status")){
                if(error.response.status === 401){
                  return this.logOut();
                }
              }
            }catch (err){

            }
            this.$message({
              message: error.message,
              showClose: true,
              type: 'error'
            });
          });
      }
    },
    mounted(){
      this.getData();
    },
    head(){
      return {
        title:'Dashboard | LazyREST',
        meta: [
          { hid: 'description', name: 'description', content: 'LazyRest api for testing/prototyping/learning' }
        ]
      }
    }
  }
</script>


<style>
  .container {
    position: absolute;
    top: 0px;
    bottom: 0px;
    width: 100%;
  }
  .container .header {
    height: 60px;
    line-height: 60px;
    background: #1D8CE0;
    color: #fff;
  }
  .container .header .userinfo {
    text-align: right;
    padding-right: 35px;
    float: right;
  }
  .container .header .userinfo .userinfo-inner {
    cursor: pointer;
    color: #fff;
  }
  .container .header .userinfo .userinfo-inner img {
    width: 40px;
    height: 40px;
    border-radius: 20px;
    margin: 10px 0px 10px 10px;
    float: right;
  }
  .container .header .logo {
    height: 60px;
    font-size: 22px;
    padding-left: 20px;
    padding-right: 20px;
  }
  .container .header .logo img {
    width: 40px;
    float: left;
    margin: 10px 10px 10px 18px;
  }
  .container .header .logo .txt {
    color: #fff;
  }
  .container .header .logo-width {
    width: 230px;
  }
  .container .header .logo-collapse-width {
    width: 60px;
  }
  .container .header .tools {
    padding: 0px 23px;
    width: 14px;
    height: 60px;
    line-height: 60px;
    cursor: pointer;
  }
  .container .main {
    display: flex;
    position: absolute;
    top: 60px;
    bottom: 0px;
    overflow: hidden;
  }
  .container .main aside {
    flex: 0 0 230px;
    width: 230px;
  }
  .container .main aside .el-menu {
    height: 100%;
  }
  .container .main aside .collapsed {
    width: 60px;
  }
  .container .main aside .collapsed .item {
    position: relative;
  }
  .container .main aside .collapsed .submenu {
    position: absolute;
    top: 0px;
    left: 60px;
    z-index: 99999;
    height: auto;
    display: none;
  }
  .container .main .menu-collapsed {
    flex: 0 0 60px;
    width: 60px;
  }
  .container .main .menu-expanded {
    flex: 0 0 230px;
    width: 230px;
  }
  .container .main .content-container {
    flex: 1;
    overflow-y: scroll;
    padding: 20px;
  }
  .container .main .content-container .breadcrumb-container .title {
    width: 200px;
    float: left;
    color: #475669;
  }
  .container .main .content-container .breadcrumb-container .breadcrumb-inner {
    float: right;
  }
  .container .main .content-container .content-wrapper {
    background-color: #fff;
    box-sizing: border-box;
  }

</style>
